//
// Created by hoelshare on 22.05.17.
//

#include "GameClient.hpp"

void GameClient::createUIGameStart() {
    if (this->playerList) {
        delete this->playerList;
    }
    playerList = new PlayerListMenu(9);
    playerList->setLeftAction([=]() { this->player->prevWeapon(); });
    playerList->setRightAction([=]() { this->player->nextWeapon(); });
    playerList->setDownAction([=]() { this->player->reload(); });
    playerList->setEnterAction([=]() { this->player->shot(); });
    LaserMenuItem *healthMI = new LaserMenuItem([]() {}, "/heart.bmp");
    LaserMenuItem *armorMI = new LaserMenuItem([]() {}, "/armor.bmp");
    LaserMenuItem *ammoMI = new LaserMenuItem([]() {}, "/ammo.bmp");
    LaserMenuItem *nameMI = new LaserMenuItem([]() {}, nullptr);
    nameMI->setText(player->getNickname());
    player->setHealthMenuItem(healthMI);
    player->setArmorMenuItem(armorMI);
    player->setAmmoMenuItem(ammoMI);
    playerList->addMenuItem(healthMI);
    playerList->addMenuItem(armorMI);
    playerList->addMenuItem(ammoMI);
    playerList->addMenuItem(nameMI);
    ui->open(playerList);
}


void GameClient::startGame() {
#ifdef DEBUG
    Serial.printf("Start Game!");
#endif
    this->createUIGameStart();
}


void GameClient::joinGame() {
    badge->setVibrator(true);
    delay(200);
    badge->setVibrator(false);
    playerList->addMenuItem(new MenuItem(player->getNickname(), []() {}));
    ui->open(playerList);
}


void GameClient::update() {

    String lastHitBy;
    int lastDamage;

    if (wasHit(&lastHitBy, &lastDamage)){
        player->hit(lastDamage);

        tft.setCursor(20, 20);
        tft.print("Hit by " + lastHitBy);
    }

}

bool GameClient::wasHit(String* nick, int* damage, bool enable) {
    // TODO: Write 'real' code
    *nick = "otter";
    *damage = 10;

    return enable;

}