//
// Created by hoelshare on 22.05.17.
//
#define AUSGABE

#include "GameServer.hpp"

void GameServer::setTeamPlay(char isTeam) {
#ifdef AUSGABE
    Serial.printf("Is team play: %s", isTeam ? "true" : "false");
#endif
    //TODO set Teamplay
}

void GameServer::secureQuestion() {
#ifdef AUSGABE
    Serial.printf("Sicherheitsabfrage!");
#endif
    secureMenu = new PlayerListMenu(4);
    secureMenu->addMenuItem(new MenuItem("Start?", [=]() { this->startGame(); }));
    secureMenu->addMenuItem(new MenuItem("Cancel?", [=]() { ui->closeCurrent(); }));
    secureMenu->setRightAction([=]() { ui->closeCurrent(); });
    secureMenu->setLeftAction([=]() { this->startGame(); });
    ui->open(secureMenu);
}

void GameServer::kick() {
    if (playerList) {
//        unsigned short index = playerList->getIndex();
        // do something with the index
    }
}

void GameServer::update() {
    if (!this->gameStarted) {
        if (server->hasClient()) {
            Serial.println("Has Client");
            serverClients[numConnections] = server->available();
            Serial.printf("New connection %d\n", numConnections);

            handleWelcome(&(serverClients[numConnections]), numConnections);
        }
    } else {
        // todo Normal game functions
    }
}

void GameServer::handleWelcome(WiFiClient *client, short iPlayer) {
    String message;
    message = client->readStringUntil('\n'); //faster the readBytesUntil()
    Serial.println(message);
    RemotePlayer player;
    player.nickname = message;
    player.pid = iPlayer;
    player.tid = 0;
    rPlayers[iPlayer] = player;
    numConnections++;
    sendAll(buildPlayerList());
}

void GameServer::sendAll(String value) {
    for (short i = 0; i < numConnections; i++) {
        serverClients[i].print(value);
        serverClients[i].flush();
    }
}

void GameServer::sendIP() {
    String shareString = "a" + WiFi.localIP().toString() + "\n";
    badge->setGPIO(IR_EN, HIGH);
    Serial.println(shareString);
    Serial.println("NEC");
    uint32_t code = 0;
    uint8_t checksum = 0;
    for (int i = 0; i < shareString.length(); i++) {
        checksum += shareString.charAt(i);
        code = code | shareString.charAt(i) << (i % 4) * 8;
        if (i % 4 == 3) {
            irsend.sendNEC(code, 32);
            Serial.println(code, HEX);
            code = 0;
        }
    }
    if (code != 0) {
        irsend.sendNEC(code, 32);
        Serial.println(code, HEX);
    }
    Serial.print("Checksum: ");
    Serial.println(checksum); //224
    code = 0;
    code = checksum << 8 | 222;
    irsend.sendNEC(code, 32);
    badge->setGPIO(IR_EN, LOW);
}

void GameServer::startGame() {
    this->gameStarted = true;
    // todo something more
}

String GameServer::buildPlayerList() {
    String ret = String(numConnections);
    for (short i = 0; i < numConnections; i++) {
        ret += "&" + rPlayers[i].serial();
    }
    ret += "\n";
    return ret;
}